{**************************************}
{ Copyright (C) MarinovSoft 2000-2006  }
{ http://marinovsoft.narod.ru          }
{ super386@rambler.ru                  }
{**************************************}
{E+}
unit f_grtext;
interface
Uses dos,graph,crt;
const
     AppHandle:Boolean = true;
     ESCFlag:boolean = false;
const
     EmptyBorder = 0;
     SingleBorder = 1;
     DoubleBorder = 2;
const
     BorderChar: array [0..2,1..6] of char =
     ((#32,  #32,  #32,  #32,  #32,  #32),
      (#218, #196, #191, #179, #192, #217),
      (#201, #205, #187, #186, #200, #188));
const
     TextCenter=2;
     TextDown=3;
     TextUp=1;
     TextLeft=3;
     TextRight=1;
function registerCHRfile(s:string):SmallInt;
procedure outstring(s:string;font:SmallInt;angle:SmallInt;mx,my:real);
procedure OutStringXY(x,y:word;STROKA:String);
procedure allfont;
procedure settextalign(horiz,vert:word);
procedure SetStyleText(Font:word;Direction:word;CharSize:word);
IMPLEMENTATION
type
    aob = array[0..maxint] of byte;
const
     changewr:boolean=false;
     font:^aob = nil;
     tcol:byte = lightgray;
     bcol:byte = black;

var
   oldout,oldinp:text;
   xt:byte;
   xg:SmallInt;
   yt:byte;
   yg:SmallInt;
   x1t,y1t,x2t,y2t:byte;
   x1g,y1g,x2g,y2g:SmallInt;
   maxchar:byte;
   maxline:byte;
   xf:byte;
   yf:byte;
   adapter:byte;
{+---------------------------------------------+
 |   প 뢮 ᮮ饭 묨     |
 |                   ⠬                  |
 +---------------------------------------------+}
type
     pfontdesc=^tfontdesc;
     tfontdesc = record
       nextfont :pfontdesc;
       nfont    :SmallInt;
       name: record
       case byte of
       0: (fname:string);
       1: (flag:byte;
          addrs:record
          sa,oa:word
          end)
       end;
       firstchr:byte;
       lastchar:byte;
       height:shortint;
       bottom:shortint;
       offs:array [0..255] of word;
       leng:array [0..255] of word;
     end;
     tfontpara = record
       parprefix: char;
       charscount: word;
       reserv1:byte;
       firstchar:byte;
       dataoffset:word;
       fillflag:byte;
       uppermargin:byte;
       reserv2:byte;
       lowermargin:shortint;
       reserv3:array [1..5] of byte
     end;
     thead = array [1..4] of char;
const
     fontlist:pfontdesc=nil;
     fontnumb:SmallInt=0;
var
   fdesc:tfontdesc;
   f:file;
   buf:array[1..128] of byte;
   head:thead absolute buf;
   fpar:tfontpara;
const
     head0:thead = ('P','K',#8,#8);
function registerchrfile(s:string):SmallInt;
var
   k:SmallInt;
   err:boolean;
   p,pd:pfontdesc;
   paroffs:word;
function readfile(var dest;size:word):boolean;
begin
     blockread(f,dest,size,k);
     readfile:=k=size
end;
begin
     if pos('.',s)=0 then
        s:=s+'.chr';
     if fontnumb<>0 then
        begin
             fdesc:=fontlist^;
             with fdesc do
             while (nextfont<>nil) and (s<>name.fname) do
                   fdesc:=nextfont^;
             if s=fdesc.name.fname then
                begin
                     registerchrfile:=fdesc.nfont;
                     exit
                end
        end;
     registerchrfile:=-1;
     assign(f,s);
     {$I-}
     reset(f,1);
     {$I+}
     if ioresult<>0 then
        exit;
     if not readfile(buf,128) then
        exit;
     registerchrfile:=-2;
     if head<>head0 then
        exit;
     repeat
           k:=1;
           while (k<=128) and (buf[k]<>$1A) do
              inc(k);
           if k=129 then
              if not readfile(buf,128) then
                 exit
     until buf[k]=$1A;
     paroffs:=buf[k+1]+buf[k+2] shl 8;
     seek(f,paroffs);
     if not readfile(fpar,16) or (fpar.parprefix<>'+') then
        exit;
     registerchrfile:=-3;
     if maxavail<sizeof(tfontdesc) then
        exit;
     new(PD);
     with pd^,fpar do
          begin
               nextfont:=nil;
               nfont:=fontnumb+1;
               name.fname:=s;
               firstchr:=firstchar;
               lastchar:=firstchar+charscount-1;
               height:=uppermargin;
               bottom:=lowermargin;
               registerchrfile:=-1;
               seek(f,paroffs+dataoffset-3*charscount);
               if not readfile(offs[firstchar],2*charscount) then
                  begin
                       dispose(PD);
                       exit
                  end;
               for k:=firstchar to lastchar do
                   offs[k]:=offs[k]+paroffs+dataoffset;
               for k:=firstchar to lastchar-1 do
                   leng[k]:=offs[k+1]-offs[k];
               leng[lastchar]:=filesize(f)-
                   offs[lastchar-1]-paroffs
          end;
     if fontnumb=0 then
        fontlist:=pd
     else
         begin
              p:=fontlist;
              while p^.nextfont<>nil do
                    p:=p^.nextfont;
              p^.nextfont:=pd
         end;
     inc(fontnumb);
     registerchrfile:=fontnumb
end;
{function registerchrfont(font:pointer):SmallInt;
type
    tbyte = array [0..65534] of byte;
var
   ph:^thead;
   pp:^tfontpara;
   pb:^tbyte absolute ph;
   p,pd:pfontdesc;
   k:SmallInt;
   paroffset:word;
   filesize:word;
begin
     ph:=font;
     registerchrfont:=-2;
     if ph^<>head0 then
        exit;
     k:=4;
     while (pb^[k] <> $1a) and (k<256) do
           inc(k);
     if pb^[k] <> $1a then
        exit;
     paroffset:=pb^[k+1]+pb^[k+2] shl 8;
     filesize:=pb^[k+7]+pb^[k+8] shl 8;
     pp:=addr(pb^[paroffset]);
     if pp^.parprefix <> '+' then
        exit;
     registerchrfont:=-3;
     if maxavail<sizeof(tfontdesc) then
        exit;
     new(pd);
     with pd^,pp^ do
          begin
               nextfont:=nil;
               nfont:=fontnumb+1;
               name.flag:=0;
               k:=paroffset+dataoffset;
               name.addrs.sa:=0;
               name.addrs.oa:=ofs(pb^[k]);
               firstchr:=firstchar;
               lastchar:=firstchar+charscount-1;
               height:=uppermargin;
               bottom:=lowermargin;
               k:=paroffset+dataoffset-3*charscount;
               move(pb^[k],offs[firstchar],2*charscount);
               for k:=firstchar to lastchar-1 do
                   leng[k]:=offs[k+1]-offs[k];
               leng[lastchar]:=filesize-offs[lastchar-1]
          end;
     if fontnumb=0 then
        fontlist:=pd
     else
         begin
              p:=fontlist;
              while p^.nextfont <> nil do
                    p:=p^.nextfont;
              p^.nextfont:=PD
         end;
     inc(fontnumb);
     registerchrfont:=fontnumb
end;}
procedure outstring(s:string;font:SmallInt;angle:SmallInt;mx,my:real);
var
   x0,y0:SmallInt;
   ang:real;
procedure outchar(var v);
var
   vec:array[1..maxint] of word absolute v;
   k,op:word;
procedure coo(x,y:SmallInt;var xx,yy:SmallInt);
var
   r,a:single;
begin
     r:=sqrt(1.0*x*x+1.0*y*y);
     if x=0 then if y<0 then
        a:=-pi/2
     else
         a:=pi/2
     else
         a:=arctan(y/x);
     a:=a+ang;
     yy:=round(r*sin(a));
     xx:=round(r*cos(a));
end;
var
   x,y,x1,y1,xx,yy:SmallInt;
begin
     k:=1;
     x:=x0;
     y:=y0;
     repeat
           op:=vec[k] and $8080;
           xx:=vec[k] and $7f;
           yy:=(vec[k] shr 8) and $7f;
           if yy>63 then
              yy:=yy-128;
           xx:=round(xx*mx);
           yy:=round(yy*my);
           coo(xx,yy,x1,y1);
           x1:=x0+x1;
           y1:=y0-y1;
           if op=$8080 then
              line(x,y,x1,y1);
           if op<>0 then
              begin
                   x:=x1;
                   y:=y1;
              end;
           if op=0 then
              begin
                   x0:=x;
                   y0:=y;
              end
           else
               inc(k)
     until op=0
end;
var
   f:file;
   k,j:word;
   c:byte;
   buf:array[1..1000] of word;
   p:pfontdesc;
   pb:pointer;
begin
     if (fontnumb=0) or
        (font>fontnumb) or (s='') then
                        exit;
     p:=fontlist;
     ang:=angle*pi/180;
     for k:=1 to font-1 do
         p:=p^.nextfont;
     with p^ do
          begin
               if name.fname<>'' then
                  begin
                       assign(f,name.fname);
                       {$I-}
                       reset(f,1);
                       {$I+}
                       if ioresult <> 0 then
                          exit;
                  end;
               x0:=getx;
               y0:=gety;
               for k:=1 to length(s) do
                   begin
                        c:=ord(s[k]);
                        if c in [firstchr..lastchar] then
                           if name.fname<>'' then
                              begin
                                   {$I-}
                                   seek(f,offs[c]);
                                   blockread(f,buf,leng[c],j);
                                   {$I+}
                                   if (ioresult=0) and (leng[c]=j) then
                                      outchar(buf)
                              end
                           else
                               with name.addrs do
                               begin
                                    pb:=ptr(sa,oa+offs[c]);
                                    outchar(PB^)
                               end
                        end;
                   moveto(x0,y0);
                   if name.fname<>'' then
                      close(f)
               end
end;
Var
   TextAngle:word;
   TextCharSizeX:real;
   TextCharSizey:real;
   CurrentFont:word;
   AlignX:word;
   AlignY:word;
procedure allfont;
begin
registerchrFile('trip.chr');
registerchrFile('litt.chr');
registerchrFile('sans.chr');
registerchrFile('goth.chr');
registerchrFile('scri.chr');
registerchrFile('simp.chr');
registerchrFile('tscr.chr');
registerchrFile('lcom.chr');
registerchrFile('euro.chr');
registerchrFile('bold.chr');
end;
procedure settextalign(horiz,vert:word);
begin
     AlignX:=Horiz;
     AlignY:=Vert;
end;
procedure SetStyleText(Font:word;Direction:word;CharSize:word);
begin
     TextAngle:=Direction;
     TextCharSizeX:=CharSize/4;
     TextCharSizeY:=CharSize/4;
     CurrentFont:=Font;
end;
procedure OutStringXY(x,y:word;STROKA:String);
const shirina:array[1..10] of byte =
      (45,15,45,50,50,40,48,49,76,50);
       visota:array[1..10] of byte =
      (55,15,50,50,50,50,50,50,105,50);
var
   rasm10:real;
   rasmxx:real;
begin
case AlignX of
     1:x:=x;
     2:begin x:=x-round(Length(STROKA)*TextCharSizeX*4*shirina[CurrentFont]/ 20);end;
     3:begin x:=x-round(Length(STROKA)*TextCharSizeX*4*shirina[CurrentFont] / 10);end;
end;
Case AlignY of
     1:y:=y;
     2:y:=y+round(textCharSizeY*4*visota[CurrentFont]/20);
     3:y:=y+round(textCharSizeY*4*visota[CurrentFont]/10);
end;
moveto(x,y);
OutString(STROKA,CurrentFont,TextAngle,TextCharSizeX,TextCharSizeY);
end;
begin
allfont;
SetStyleText(1,1,10);
end.